searchNodes=[{"doc":"","ref":"DCache.html","title":"DCache","type":"module"},{"doc":"Clears the cache. While the cache is being cleared, concurrent activity is severely limited.","ref":"DCache.html#clear/1","title":"DCache.clear/1","type":"function"},{"doc":"Creates a module to wrap cache operations. This is the preferred way to create a cache as it performs better. defmodule App.Cache do require DCache DCache . define ( Users , 100_000 ) # creates an App.Cache.Users module end opts: cache : Module The name of the module to create . This will be nested within the calling module max : integer The maximum number of items to hold in the cache opts : segments : integer The number of segments to create ( defaults to 100 , 10 , 3 or 1 ) depending on ` max ` purger : symbol | function The purger to use , defaults to ` :fast ` Supported values : ` :fast ` , ` :fast_no_spawn ` , ` :expired ` , ` :expired_no_spawn ` , ` :blocking ` , ` :none ` or a custom function","ref":"DCache.html#define/3","title":"DCache.define/3","type":"macro"},{"doc":"Deletes the value from the cache, safe to call even if the key is not in the cache","ref":"DCache.html#del/2","title":"DCache.del/2","type":"function"},{"doc":"Destroys the cache. Any call to the cache once destroy is called will raise an ArgumentError.","ref":"DCache.html#destroy/1","title":"DCache.destroy/1","type":"function"},{"doc":"Iterates each segment name. fun will receive the segment name.","ref":"DCache.html#each_segments/2","title":"DCache.each_segments/2","type":"function"},{"doc":"Gets the entry from the cache, or nil if not found. The entry will be returned even if it has expired. The entry is an internal representation that can change. You can use DCache.Entry.key/1 , DCache.Entry.value/1 and DCache.Entry.ttl/1 to extract the key, value and ttl from an entry","ref":"DCache.html#entry/2","title":"DCache.entry/2","type":"function"},{"doc":"Same as fetch, but unwraps the returned value or raises on error.","ref":"DCache.html#fetch!/4","title":"DCache.fetch!/4","type":"function"},{"doc":"Gets the value from the cache. Executes fun/1 if the value is not found. fun/1 receives the cache key being looked up and should return one of: * ` { :ok , value } ` * ` { :ok , value , ttl } ` * ` { :skip , value } ` * ` { :error , term } `","ref":"DCache.html#fetch/4","title":"DCache.fetch/4","type":"function"},{"doc":"Gets the value from the cache, returning nil if not found or expired","ref":"DCache.html#get/2","title":"DCache.get/2","type":"function"},{"doc":"Puts the value in the cache. TTL is a relative time in second. For example, 300 would mean that the value would expire in 5 minutes","ref":"DCache.html#put/4","title":"DCache.put/4","type":"function"},{"doc":"Reduces each segment name. fun will receive the segment name (which is the name of an ETS table) plus the accumulator","ref":"DCache.html#reduce_segments/3","title":"DCache.reduce_segments/3","type":"function"},{"doc":"Creates the cache opts: cache : atom The name of the cache max : integer The maximum number of items to hold in the cache opts : segments : integer The number of segments to create ( defaults to 100 )","ref":"DCache.html#setup/3","title":"DCache.setup/3","type":"function"},{"doc":"Returns the total number of items in the cache, including expired items. This is O(N) over the number of segments","ref":"DCache.html#size/1","title":"DCache.size/1","type":"function"},{"doc":"Deletes and removes the value from the cache. Returns nil if not found. Returns {:ok, {key, value, expires}} if found","ref":"DCache.html#take/2","title":"DCache.take/2","type":"function"},{"doc":"Returns the time in second until the value expires. nil if the key isn't found. Can return a negative value if the item has expired but has not been purged yet","ref":"DCache.html#ttl/2","title":"DCache.ttl/2","type":"function"},{"doc":"Some cache functions return the internal structure of a key=&gt;value pair stored within the cache. Future versionsof DCache can change this internal structure. This module provides functions to extract the data from this structure so that libraries do not need to know about the structure or worry about future changes.","ref":"DCache.Entry.html","title":"DCache.Entry","type":"module"},{"doc":"Extracts the :erlang . monotonic_time ( :second ) when the entry will expire . Returns nil if the entry is nil . This value will be in the past for already expired entries .","ref":"DCache.Entry.html#expiry/1","title":"DCache.Entry.expiry/1","type":"function"},{"doc":"Extracts the key from the entry . Returns nil if the entry is nil","ref":"DCache.Entry.html#key/1","title":"DCache.Entry.key/1","type":"function"},{"doc":"Extracts the ttl in seconds from the entry . Returns nil if the entry is nil . The returned value will be negative for already expired entries .","ref":"DCache.Entry.html#ttl/1","title":"DCache.Entry.ttl/1","type":"function"},{"doc":"Extracts the value from the entry . Returns nil if the entry is nil .","ref":"DCache.Entry.html#value/1","title":"DCache.Entry.value/1","type":"function"}]